#!/usr/bin/ruby -Ke

require "net/telnet"

SideLength=15

# ƥץ졼ȥޥå󥰤ΤΥϥåƤ;Ϥꡥ
Match_5_hash={[0,0,0,0,0]=>true}
Match_5_hash.default=false
Match_4_hash={[100,0,0,0,0,100]=>true}
Match_4_hash.default=false
Match_4_split_hash={
  [0,0,0,100,0]=>true,
  [0,0,100,0,0]=>true,
  [0,100,0,0,0]=>true
}
Match_4_split_hash.default=false
Match_4_defended_hash={
  [100,0,0,0,0,1]=>true,
  [1,0,0,0,0,100]=>true
}
Match_4_defended_hash.default=false
Match_3_hash={[100,0,0,0,100]=>true}
Match_3_hash.default=false
Match_3_split_hash={
  [100,0,0,100,0,100]=>true,
  [100,0,100,0,0,100]=>true
}
Match_3_split_hash.default=false
Match_3_defended_hash={
  [100,0,0,0,1]=>true,
  [1,0,0,0,100]=>true
}
Match_3_defended_hash.default=false
Match_2_hash={[100,0,0,100]=>true}
Match_2_hash.default=false
Match_2_split_hash={
  [100,0,100,0,100]=>true
}
Match_2_split_hash.default=false
Match_1_hash={[100,0,100]=>true}
Match_1_hash.default=false
Match_4_enemy_hash={
  [100,1,1,1,1]=>true,
  [1,100,1,1,1]=>true,
  [1,1,100,1,1]=>true,
  [1,1,1,100,1]=>true,
  [1,1,1,1,100]=>true
}
Match_4_enemy_hash.default=false
Match_3_enemy_hash={
  [0,100,1,1,1,100]=>true,
  [1,100,1,1,1,100]=>true,
  [100,100,1,1,1,100]=>true,
  [100,1,100,1,1,100]=>true,
  [100,1,1,100,1,100]=>true,
  [100,1,1,1,100,0]=>true,
  [100,1,1,1,100,1]=>true,
  [100,1,1,1,100,100]=>true
}
Match_3_enemy_hash.default=false
Match_2_enemy_hash={
  [100,1,1,100,0]=>true,
  [100,1,1,100,100]=>true,
  [100,1,100,1,100]=>true,
  [0,100,1,1,100]=>true,
  [100,100,1,1,100]=>true
}
Match_2_split_hash.default=false

# ̤ξݻ륯饹
class Board
  # ܤξݻ륯饹(Ф롤ޤ϶)
  class Cross
    def initialize
      @black=false
      @white=false
    end
    def put_black
      @black=true
    end
    def put_white
      @white=true
    end
    def output_black
      @black
    end
    def output_white
      @white
    end
    def get_color
      if @black
        "black"
      elsif @white
        "white"
      else
        ""
      end
    end
  end # end class Cross
  # ̤ξ᥽å
  def initialize
#    SideLength=19
    @board=Array.new(SideLength){Array.new(SideLength){Cross.new}}
  end
  # ̤ɽ᥽å
  def print_board
    top=0
    side=0
    print "\n"
    @board.each do |row|
      if top==0
        print " "
        for top in 0...SideLength
          print "#{top%10} "
        end
        print "\n"
      end
      print "#{side%10}"
      side+=1
      row.each do |cross|
        if cross.output_black==true then
          print ""
        elsif cross.output_white==true then
          print ""
        else
          print ""
        end
      end
      print "\n"
    end
    print "\n"
  end
  def sequence_num_5(row,column,color)
    col_flag=row_flag=diag0_flag=diag1_flag=true
    for delta in 1...5
      if column+delta >= SideLength then
        col_flag=false
        diag0_flag=false
      elsif @board[row][column+delta].get_color!=color then
        col_flag=false
      end
      if row+delta >= SideLength then
        row_flag=false
        diag0_flag=false
        diag1_flag=false
      elsif @board[row+delta][column].get_color!=color then
        row_flag=false
      end
      if diag0_flag==true then
        if @board[row+delta][column+delta].get_color!=color then
          diag0_flag=false
        end
      end
      if diag1_flag==true then
        if column-delta<0 then
          diag1_flag=false
        elsif @board[row+delta][column-delta].get_color!=color then
          diag1_flag=false
        end
      end
      if (col_flag || row_flag || diag0_flag || diag1_flag) == false
        return false
      end
    end
    return true
  end
  # Ƥ뤫ݤȽ̤᥽å
  # ֤ͤ true ʤХץཪλ
  def win
    for row in 0...SideLength do
      for column in 0...SideLength do
        color=@board[row][column].get_color
        if color != ""
          if sequence_num_5(row,column,color)
            win=color
          end
        end
      end
    end
    case win
    when "black"
      print "()ξǤ\n"
      return true
    when "white"
      print "()ξǤ\n"
      return true
    else
      return false
    end
  end

  # ȤΥ󥿡ե
  def put_black(row,column)
    @board[row][column].put_black
  end
  def put_white(row,column)
    @board[row][column].put_white
  end

  def output_black_ext(row,column)
    @board[row][column].output_black
  end
  def output_white_ext(row,column)
    @board[row][column].output_white
  end
  def output_sl
    SideLength
  end

end # end class Board

# ̤Ф֤饹ΤȤ桼󥿡եͤƤߤꤹ롥
class Play
  class Com < Play
    class Eval < Com
      def initialize
      end
      def ver(putable_row, putable_column, s_e_hash, num)
        ver_chain=[]
        for i in 0...num do
          ver_chain.push s_e_hash[[putable_row-i,putable_column]]
        end
        return ver_chain
      end
      def hor(putable_row, putable_column, s_e_hash, num)
        hor_chain=[]
        for i in 0...num do
          hor_chain.push s_e_hash[[putable_row,putable_column-i]]
        end
        return hor_chain
      end
      def diag1(putable_row, putable_column, s_e_hash, num)
        diag1_chain=[]
        for i in 0...num do
          diag1_chain.push s_e_hash[[putable_row-i,putable_column-i]]
        end
        return diag1_chain
      end
      def diag2(putable_row, putable_column, s_e_hash, num)
        diag2_chain=[]
        for i in 0...num do
          diag2_chain.push s_e_hash[[putable_row-i,putable_column+i]]
        end
        return diag2_chain
      end
      def match_5(stones)
        return Match_5_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_5(putable, s_e_hash)
        for delta in 0..4 do
          if match_5(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            return true
          end
          if match_5(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            return true
          end
          if match_5(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            return true
          end
          if match_5(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            return true
          end
        end 
        return false
      end
      def match_4(stones)
        return Match_4_hash[[stones[0],stones[1],stones[2],stones[3],stones[4],stones[5]]]
      end
      def nanafushi_4(putable, s_e_hash)
        num_of_4=0
        for delta in 0..5 do
          if match_4(ver(putable[0]+delta, putable[1], s_e_hash, 6)) then
            num_of_4+=1
          end
          if match_4(hor(putable[0], putable[1]+delta, s_e_hash, 6)) then
            num_of_4+=1
          end
          if match_4(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 6)) then
            num_of_4+=1
          end
          if match_4(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 6)) then
            num_of_4+=1
          end
        end 
        return num_of_4
      end
      def match_4_split(stones)
        return Match_4_split_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_4_split(putable, s_e_hash)
        num_of_4_split=0
        for delta in 0..4 do
          if match_4_split(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            num_of_4_split+=1
          end
          if match_4_split(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            num_of_4_split+=1
          end
          if match_4_split(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            num_of_4_split+=1
          end
          if match_4_split(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            num_of_4_split+=1
          end
        end 
        return num_of_4_split
      end
      def match_4_defended(stones)
        return Match_4_defended_hash[[stones[0],stones[1],stones[2],stones[3],stones[4],stones[5]]]
      end
      def nanafushi_4_defended(putable, s_e_hash)
        num_of_4_defended=0
        for delta in 0..5 do
          if match_4_defended(ver(putable[0]+delta, putable[1], s_e_hash, 6)) then
            num_of_4_defended+=1
          end
          if match_4_defended(hor(putable[0], putable[1]+delta, s_e_hash, 6)) then
            num_of_4_defended+=1
          end
          if match_4_defended(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 6)) then
            num_of_4_defended+=1
          end
          if match_4_defended(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 6)) then
            num_of_4_defended+=1
          end
        end 
        return num_of_4_defended
      end
      def match_3(stones)
        return Match_3_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_3(putable, s_e_hash)
        num_of_3=0
        for delta in 0..4 do
          if match_3(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            num_of_3+=1
          end
          if match_3(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            num_of_3+=1
          end
          if match_3(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            num_of_3+=1
          end
          if match_3(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            num_of_3+=1
          end
        end 
        return num_of_3
      end
      def match_3_split(stones)
        return Match_3_split_hash[[stones[0],stones[1],stones[2],stones[3],stones[4],stones[5]]]
      end
      def nanafushi_3_split(putable, s_e_hash)
        num_of_3_split=0
        for delta in 0..5 do
          putable_row=putable[0]
          putable_column=putable[1]
          if match_3_split(ver(putable[0]+delta, putable[1], s_e_hash, 6)) then
            num_of_3_split+=1
          end
          if match_3_split(hor(putable[0], putable[1]+delta, s_e_hash, 6)) then
            num_of_3_split+=1
          end
          if match_3_split(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 6)) then
            num_of_3_split+=1
          end
          if match_3_split(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 6)) then
            num_of_3_split+=1
          end
        end 
        return num_of_3_split
      end
      def match_2(stones)
        return Match_2_hash[[stones[0],stones[1],stones[2],stones[3]]]
      end
      def nanafushi_2(putable, s_e_hash)
        num_of_2=0
        for delta in 0..3 do
          if match_2(ver(putable[0]+delta, putable[1], s_e_hash, 4)) then
            num_of_2+=1
          end
          if match_2(hor(putable[0], putable[1]+delta, s_e_hash, 4)) then
            num_of_2+=1
          end
          if match_2(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 4)) then
            num_of_2+=1
          end
          if match_2(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 4)) then
            num_of_2+=1
          end
        end 
        return num_of_2
      end
      def match_2_split(stones)
        return Match_2_split_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_2_split(putable, s_e_hash)
        num_of_2_split=0
        for delta in 0..4 do
          if match_2_split(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            num_of_2_split+=1
          end
          if match_2_split(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            num_of_2_split+=1
          end
          if match_2_split(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            num_of_2_split+=1
          end
          if match_2_split(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            num_of_2_split+=1
          end
        end 
        return num_of_2_split
      end
      def match_4_enemy(stones)
        return Match_4_enemy_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_4_enemy_sub(putable, s_e_hash)
        num_of_4_enemy=0
        for delta in 0..4 do
          if match_4_enemy(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            num_of_4_enemy+=1
          end
          if match_4_enemy(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            num_of_4_enemy+=1
          end
          if match_4_enemy(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            num_of_4_enemy+=1
          end
          if match_4_enemy(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            num_of_4_enemy+=1
          end
        end 
        return num_of_4_enemy
      end
      def nanafushi_4_enemy(enemy_ary, s_e_hash)
        sum_num_of_4_enemy=0
        enemy_ary.each do |enemy_stone|
          sum_num_of_4_enemy+=nanafushi_4_enemy_sub(enemy_stone, s_e_hash)
        end
        return sum_num_of_4_enemy
      end
      def match_3_enemy(stones)
        return Match_3_enemy_hash[[stones[0],stones[1],stones[2],stones[3],stones[4],stones[5]]]
      end
      def nanafushi_3_enemy_sub(putable, s_e_hash)
        num_of_3_enemy=0
        for delta in 0..5 do
          if match_3_enemy(ver(putable[0]+delta, putable[1], s_e_hash, 6)) then
            num_of_3_enemy+=1
          end
          if match_3_enemy(hor(putable[0], putable[1]+delta, s_e_hash, 6)) then
            num_of_3_enemy+=1
          end
          if match_3_enemy(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 6)) then
            num_of_3_enemy+=1
          end
          if match_3_enemy(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 6)) then
            num_of_3_enemy+=1
          end
        end 
        return num_of_3_enemy
      end
      def nanafushi_3_enemy(enemy_ary, s_e_hash)
        sum_num_of_3_enemy=0
        enemy_ary.each do |enemy_stone|
          sum_num_of_3_enemy+=nanafushi_3_enemy_sub(enemy_stone, s_e_hash)
        end
        return sum_num_of_3_enemy
      end
      def match_2_enemy(stones)
        return Match_2_enemy_hash[[stones[0],stones[1],stones[2],stones[3],stones[4]]]
      end
      def nanafushi_2_enemy_sub(putable, s_e_hash)
        num_of_2_enemy=0
        for delta in 0..4 do
          if match_2_enemy(ver(putable[0]+delta, putable[1], s_e_hash, 5)) then
            num_of_2_enemy+=1
          end
          if match_2_enemy(hor(putable[0], putable[1]+delta, s_e_hash, 5)) then
            num_of_2_enemy+=1
          end
          if match_2_enemy(diag1(putable[0]+delta, putable[1]+delta, s_e_hash, 5)) then
            num_of_2_enemy+=1
          end
          if match_2_enemy(diag2(putable[0]+delta, putable[1]-delta, s_e_hash, 5)) then
            num_of_2_enemy+=1
          end
        end 
        return num_of_2_enemy
      end
      def nanafushi_2_enemy(enemy_ary, s_e_hash)
        sum_num_of_2_enemy=0
        enemy_ary.each do |enemy_stone|
          sum_num_of_2_enemy+=nanafushi_2_enemy_sub(enemy_stone, s_e_hash)
        end
        return sum_num_of_2_enemy
      end
      def nanafushi(putable, self_ary, enemy_ary)
        eval_nanafushi=0
        self_enemy_hash=Hash.new
        self_enemy_hash.default=100
        self_ary.each do |sel|
          self_enemy_hash.store(sel, 0)
        end
        enemy_ary.each do |ene|
          self_enemy_hash.store(ene, 1)
        end
        for row in 0..15 do
          self_enemy_hash.store([row,-1], 1)
          self_enemy_hash.store([row,15], 1)
        end
        for column in 1..14 do
          self_enemy_hash.store([-1,column], 1)
          self_enemy_hash.store([15,column], 1)
        end
        if nanafushi_5(putable, self_enemy_hash) then
          return 99999999999999
        end
        nana_4=nanafushi_4(putable, self_enemy_hash)
        nana_4_split=nanafushi_4_split(putable, self_enemy_hash)
        nana_4_defended=nanafushi_4_defended(putable, self_enemy_hash)
        nana_3=nanafushi_3(putable, self_enemy_hash)
        nana_3_split=nanafushi_3_split(putable, self_enemy_hash)
        if nana_3+nana_3_split>1 then
          return -9999999999999
        elsif nana_4+nana_4_split+nana_4_defended+nana_3+nana_3_split>1 then
           eval_nanafushi+=2000
        else
          eval_nanafushi+=3000*nana_4
          eval_nanafushi+=80*nana_4_split
          eval_nanafushi+=80*nana_4_defended
          eval_nanafushi+=100*nana_3
          eval_nanafushi+=50*nana_3_split
        end
        eval_nanafushi+=20*nanafushi_2(putable, self_enemy_hash)
        eval_nanafushi+=10*nanafushi_2_split(putable, self_enemy_hash)
        eval_nanafushi-=2500*nanafushi_4_enemy(enemy_ary, self_enemy_hash)
        eval_nanafushi-=300*nanafushi_3_enemy(enemy_ary, self_enemy_hash) 
        eval_nanafushi-=12*nanafushi_2_enemy(enemy_ary, self_enemy_hash)
        return eval_nanafushi
      end
      def run(putable_ary, self_ary, enemy_ary, board_tmp)
        @board=board_tmp
        eval=Hash.new
        eval_kumo=0
        putable_ary.each do |putable|
          self_ary.push putable # Ф1֤ˤĤɾ
          eval_nanafushi=nanafushi(putable, self_ary, enemy_ary)
          eval.store(putable, eval_nanafushi)
          self_ary.pop
        end
        #p eval
        return eval
      end
    end # end class Eval < Com
    def gen_self_enemy_arr
      black=[]
      white=[]
      for row in 0...SideLength
        for column in 0...SideLength
          if @board.output_black_ext(row,column)==true then
            black<<[row,column]
          elsif @board.output_white_ext(row,column)==true then
            white<<[row,column]
          end
        end
        if @self_color == "white"
          @self=white
          @enemy=black
        else
          @self=black
          @enemy=white
        end
      end
    end
    def gen_putable_arr
      putable=[]
      if putable == [] then
        all_cross=[]
        all_cross_arround=[]
        all_cross=@self+@enemy
        all_cross.each{ |pt|
          all_cross_arround << [pt[0]-1, pt[1]-1]
          all_cross_arround << [pt[0]-1, pt[1]+0]
          all_cross_arround << [pt[0]-1, pt[1]+1]
          all_cross_arround << [pt[0]+0, pt[1]-1]
          all_cross_arround << [pt[0]+0, pt[1]+1]
          all_cross_arround << [pt[0]+1, pt[1]-1]
          all_cross_arround << [pt[0]+1, pt[1]+0]
          all_cross_arround << [pt[0]+1, pt[1]+1]
        }
        all_cross_arround.reject! {|pt| pt[0]<0 || pt[1]<0 || pt[0]>=SideLength || pt[1]>=SideLength }
        all_cross_arround.uniq!
        all_cross.each{ |pt| 
          all_cross_arround.delete(pt) 
        }
        putable = all_cross_arround.sort
      end
      if putable==[] then
        initial_put=[SideLength/2,SideLength/2]
        putable.push initial_put
      end
      return putable
    end
    def random_place
      if @putable.length == 0 then
        place=[SideLength/2,SideLength/2]
      else
        place=@putable[rand(@putable.length)]
      end
      return place
    end
    def decide_place(eval)
      max_val=-1000000
      max_key=[]
      eval.each{ |key,val|
        if max_val < val then
          max_val=val
          max_key=key
        elsif (max_val==val)&&(rand(2)==1) then
          max_val=val
          max_key=key
        end
      }
      if max_key==[] then
        return random_place
      else
        return max_key
      end
    end
    def run(board_tmp,self_color)
      @board=board_tmp
      @self_color=self_color
      gen_self_enemy_arr
      @putable=gen_putable_arr
      eval=Eval.new.run(@putable,@self,@enemy,@board)
      if true then
        place=decide_place(eval) 
      else
        place=random_place
      end
      return place
    end
  end # end class Com < Play
  def initialize
    @board=Board.new
  end
  def input_place_black
    while 1 do
      if false then
        print "()ιǤ\n"
        print "\",\" ڤФ֤κɸꤷƤ: 10,12\n"
        place=gets.chop!.split(",")
      else
        place=@com.run(@board,"black")
      end
      print ":[#{place[0]},#{place[1]}]\n"
      begin
        if place[0]==nil || place[1]==nil || place[2]!=nil then raise end
        if Integer(place[0])>=SideLength || Integer(place[0])<0 || Integer(place[1])>=SideLength || Integer(place[1])<0 then raise end
      rescue
        print "ϤηäƤޤ褦ꤤޤ\n"
      else
        begin
          if @board.output_black_ext(Integer(place[0]),Integer(place[1])) || @board.output_white_ext(Integer(place[0]),Integer(place[1]))then raise end
        rescue
          print "ΰ֤ˤϴФ֤Ƥޤ\n"
        else
          @board.put_black(Integer(place[0]),Integer(place[1]))
          break
        ensure
        end
      ensure
      end
    end
  end
  def input_place_white
    while 1 do
      if false then
        print "()ιǤ\n"
        print "\",\" ڤФ֤κɸꤷƤ: 10,12\n"
        place=gets.chop!.split(",")
      else
        place=@com.run(@board,"white")
      end
      print ":[#{place[1]},#{place[0]}]\n"
      begin
        if place[0]==nil || place[1]==nil || place[2]!=nil then raise end
        if Integer(place[0])>=SideLength || Integer(place[0])<0 || Integer(place[1])>=SideLength || Integer(place[1])<0 then raise end
      rescue
        print "ϤηäƤޤ褦ꤤޤ\n"
      else
        begin
          if @board.output_black_ext(Integer(place[0]),Integer(place[1])) || @board.output_white_ext(Integer(place[0]),Integer(place[1]))then raise end
        rescue
          print "ΰ֤ˤϴФ֤Ƥޤ\n"
        else
          @board.put_white(Integer(place[0]),Integer(place[1]))
          break
        ensure
        end
      ensure
      end
    end
  end
  def run
    @com=Com.new
    @board.print_board
    phase=false # phase==false -> ֡  phase==true -> 
    while 1 do # Ĥޤǲ
      if phase==false then
        input_place_black
        phase=true
      elsif phase==true then
        input_place_white
        phase=false
      end
      @board.print_board
      if @board.win then  # Ƚ
        break
      end
    end
  end
end # end class Play

class Play_by_client < Play
  def get_board_text
    @host.puts("get text")
    @host.waitfor(/\W{15}\n/) do |c|
      row=0
      c.each do |line|
        for column in 0...SideLength
          if line[column]==64 then
            @board.put_black(row,column)
          elsif line[column]==111 then
            @board.put_white(row,column)
          end
        end
        row+=1
      end
    end
  end
  def run_client(host)
    @com=Com.new
    @host=host
    while 1 do # Ĥޤǲ
      @host.waitfor(/your turn/)
      get_board_text
      @board.print_board
      if ARGV[1]=="10000"||ARGV[2]=="-b"||ARGV[2]==nil then
        black=true
      elsif ARGV[2]=="-w" then
        black=false
      end
      if black then
        place=@com.run(@board,"black")
      else
        place=@com.run(@board,"white")
      end
      pl=[place[1],place[0]]
      p pl
      place_row=place[1]
      place_column=place[0]
      @host.puts("put #{place_row} #{place_column}")
      @host.waitfor(/\W/) {|c| print c}
    end
  end
end

class Client
  def initialize
    @play_by_client=Play_by_client.new
  end
  def run
    @host=Net::Telnet::new(
                           "Host" => ARGV[0],
                           "Port" => ARGV[1],
                           "Output_log" => "telnetout.log",
                           "Timeout"    => 3600, # 1֤ǥॢ
                           "dump_log" => "telnetdump.log",
                           "Prompt" => /your turn/
                           )
    @play_by_client.run_client(@host)
  end
end

if ARGV[0]!=nil && ARGV[1]!=nil then
  Client.new.run
else
  Play.new.run
end
